Attribute VB_Name = "RenderDX"

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Andrew Gits

Public Running As Boolean
   'Wird "Running" False so beendet sich das Programm selbst.

Const FVF = D3DFVF_XYZRHW Or D3DFVF_TEX1 Or D3DFVF_DIFFUSE Or _
            D3DFVF_SPECULAR 'Vertex Shader

Public TriStrip(0 To 3) As D3DTLVERTEX

Public DX As New DirectX8
Public D3Dx As New D3DX8
Public D3D As Direct3D8
Dim D3DDevice As Direct3DDevice8
Dim myTexture As Direct3DTexture8

Public Sub Render()

   Do
      D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET, &HFF&, 1#, 0
         'Device (Bildschirm) fr die Grafikoperationen freirumen.
         
      D3DDevice.BeginScene
      D3DDevice.SetTexture 0, myTexture
      D3DDevice.SetTextureStageState 0, D3DTSS_COLOROP, D3DTOP_MODULATE
      D3DDevice.SetTextureStageState 0, D3DTSS_COLORARG1, D3DTA_TEXTURE
      D3DDevice.SetTextureStageState 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE
      D3DDevice.SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_DISABLE

      D3DDevice.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, _
         TriStrip(0), Len(TriStrip(0))
            'Zeichnet das Quadrat mit der "TriangleStrip" Methode.
    
         D3DDevice.EndScene
         D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
            'Zeichnet den Backbuffer auf den Screen.
            
         DoEvents
         
    Loop Until Running = False
    
Unload Form1

End Sub
Public Function Init3d() As Boolean

   On Error GoTo ErrHandler
    
   Init3d = False
    
   Set D3D = DX.Direct3DCreate()
   If D3D Is Nothing Then Exit Function
    
   Dim DxMode As D3DDISPLAYMODE
   D3D.GetAdapterDisplayMode D3DADAPTER_DEFAULT, DxMode
      'Speichert die aktuellen Grafikeinstellungen.

    
   'DxMode.Format = D3DFMT_X8R8G8B8    '32-bit mode
   DxMode.Format = D3DFMT_R5G6B5       '16-bit mode
   DxMode.Width = 640                  'Auflsung: 640 x 480
   DxMode.Height = 480
    
   Dim D3dpp As D3DPRESENT_PARAMETERS
   D3dpp.Windowed = False              'Vollbild
   
   D3dpp.SwapEffect = D3DSWAPEFFECT_FLIP  'UFLIP swap Methode
   D3dpp.BackBufferFormat = DxMode.Format
   D3dpp.BackBufferWidth = DxMode.Width   'Backbuffer Auflsung
   D3dpp.BackBufferHeight = DxMode.Height

   D3dpp.FullScreen_PresentationInterval = _
      D3DPRESENT_INTERVAL_IMMEDIATE 'Latenzzeit zum Flippen.
      
   D3dpp.FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT
      'Refresh Rate in Herz
    
   Set D3DDevice = D3D.CreateDevice(D3DADAPTER_DEFAULT, _
                     D3DDEVTYPE_HAL, Form1.hWnd, _
                     D3DCREATE_SOFTWARE_VERTEXPROCESSING, D3dpp)
                        'Erzeugt das Device
                     
   If D3DDevice Is Nothing Then Exit Function
      'Bei einem Fehler wird die Funktion verlassen.

   D3DDevice.SetVertexShader FVF
      'Vertrex Shader wird gesetzt.
    
   Init3d = True
   
Exit Function
    
ErrHandler:
    Init3d = False
    
End Function
Public Function InitData() As Boolean

   Dim strPfad As String

   InitData = False
   strPfad = App.Path + "\visual-basic-world.gif" 'texture.bmp"
    
      Set myTexture = CreateNewTexture(D3DDevice, strPfad)

   TriStrip(0) = CreateTLVertex(10, 10, 0, 1, 16777215, 0, 0, 0)
   TriStrip(1) = CreateTLVertex(210, 10, 0, 1, 16777215, 0, 1, 0)
   TriStrip(2) = CreateTLVertex(10, 110, 0, 1, 16777215, 0, 0, 1)
   TriStrip(3) = CreateTLVertex(210, 110, 0, 1, 16777215, 0, 1, 1)
   
   InitData = True
    
End Function
Public Function CreateNewTexture(dev As Direct3DDevice8, src As String)

    Dim TempTexture As Direct3DTexture8
    
    If Dir$(src) = "" Then
        CreateNewTexture = ""
        Exit Function
    End If
    
    Set TempTexture = D3Dx.CreateTextureFromFile(dev, src)
      'Textur wird erzeugt.
      
    If TempTexture Is Nothing Then Exit Function
      'Wenn das Erzeugen der Textur fehlschlgt.
    
    Set CreateNewTexture = TempTexture
    
End Function
Private Function CreateTLVertex(X As Single, Y As Single, Z As Single, rhw As Single, color As Long, specular As Long, tu As Single, tv As Single) As D3DTLVERTEX

   CreateTLVertex.sx = X 'X (horizontal)
   CreateTLVertex.sy = Y 'Y (vertikal)
   CreateTLVertex.sz = Z 'Z (Tiefe)
   CreateTLVertex.rhw = rhw
   CreateTLVertex.color = color 'Farbe i.d.R. wei fr Polygone
   CreateTLVertex.specular = specular
   CreateTLVertex.tu = tu 'Texture Koordinate (x val)
   CreateTLVertex.tv = tv 'Texture Koordinate (y val)
    
End Function
Public Sub End3d()

   On Error Resume Next
    
   Set D3D = Nothing
   Set D3DDevice = Nothing
   Set DX = Nothing
      'Alle geffneten DirectX Elemente werden entladen.
    
End Sub
